//+------------------------------------------------------------------+
//|                                #1 BUY 25 BB by Steve Hopwood.mq4 |
//|                                  Copyright  2010, Steve Hopwood |
//|                              http://www.hopwood3.freeserve.co.uk |
//+------------------------------------------------------------------+
#property copyright "Copyright  2010, Steve Hopwood"
#property link      "http://www.hopwood3.freeserve.co.uk"
#include <WinUser32.mqh>
#include <stdlib.mqh>

/*
bool SendSingleTrade(int type, string comment, double lotsize, double price, double stop, double take)
bool DoesTradeExist()
void CalculateCandleLength(int shift)

bool No_1_BUY_25_BB()
bool No_1_SELL_25_BB()
bool No_2_BUY_1MA_25_BB()
bool No_2_SELL_1MA_25_BB()
bool No_3_BUY_BULGE_BB()
bool No_3_SELL_BULGE_BB()
bool No_4_BUY_25_BB_or_1x3()
bool No_4_SELL_25_BB_or_1x3()
bool No_7_BUY_25_BB_after_diverge()
bool No_7_SELL_25_BB_after_diverge()

*/

extern double  Lot=0.01;
extern double  TakeProfit=0;
extern double  StopLoss=0;
extern int     MagicNumber=1;
extern bool    CriminalIsECN=false;
extern bool    UseSafetyFeature=true;
extern string  bl="-------------------------------------------------";
extern bool    Trade_1_BUY_25_BB=false;
extern bool    Trade_1_SELL_25_BB=false;
extern bool    Trade_2_BUY_1MA_25_BB=false;
extern bool    Trade_2_SELL_1MA_25_BB=false;
extern bool    Trade_3_BUY_BULGE_BB=false;
extern bool    Trade_3_SELL_BULGE_BB=false;
extern bool    Trade_4_BUY_25_BB_or_1x3=false;
extern bool    Trade_4_SELL_25_BB_or_1x3=false;
extern bool    Trade_7_BUY_25_BB_post_diverge=false;
extern bool    Trade_7_SELL_25_BB_post_diverge=false;


extern string  dv="Divergence inputs for #7";
extern int     MaximumCandleLength=20;
extern double  AllowableWickPercentage=49;
extern int     RsiPeriod=21;

double         BbUpper, BbLower;
bool           RobotSuspended;
int            OldBars;

//Length of the trading candle and wick percentage for #7
//Note: I copied this routine directly from the AshFX V2 robot; some of the variables are redundant here
double         AverageCandleLength;
double         CurrentCandleLength;
double         TradeableCandleLength;//Av length plus CandleLengthOverAverage%
//Wick lengths and percentages of candle length
double         UpperWickLength;
double         UpperWickPercent;
double         LowerWickLength;
double         LowerWickPercent;

//+------------------------------------------------------------------+
//| expert initialization function                                   |
//+------------------------------------------------------------------+
int init()
{
//----

   //Accommodate different quote sizes
   double multiplier;
   if(Digits == 2 || Digits == 4) multiplier = 1;
   if(Digits == 3 || Digits == 5) multiplier = 10;
   if(Digits == 6) multiplier = 100;   
   TakeProfit*= multiplier;
   StopLoss*= multiplier;
   
   if (UseSafetyFeature)
   {
      
      int retval = MessageBox(Symbol() + ": do you wish to continue to use this robot?", "Question", MB_YESNO|MB_ICONQUESTION);
      if (retval == IDNO) RobotSuspended = true;
      else RobotSuspended = false;   
   }//if (UseSafetyFeature)
   
   OldBars = Bars;
   
//----
   return(0);
}
//+------------------------------------------------------------------+
//| expert deinitialization function                                 |
//+------------------------------------------------------------------+
int deinit()
{
//----
   
//----
   return(0);
}

void CalculateCandleLength(int shift)
{
   //Calculates the length of the candle indicated by shift.
   //This will be the current candle for display purposes, and the trading candle at the open of the new one.
   //Calculates the length of the upper and lower wicks, and their percentage of the candle length
   
   double Chigh = High[shift];
   double Clow = Low[shift];
   
   CurrentCandleLength = NormalizeDouble(MathAbs(Chigh - Clow), Digits);
   
   //Calculate wick lengths
   //Up candle
   if (Close[shift] > Open[shift])
   {
      UpperWickLength = Chigh - Ask;
      LowerWickLength = Open[shift] - Clow;   
   }//if (Close[shift] > Open[shift])
   
   //Down candle
   if (Close[shift] < Open[shift])
   {
      UpperWickLength = Chigh - Open[shift];
      LowerWickLength = Bid - Clow;   
   }//if (Close[shift] < Open[shift])

   //Calculate percentage of candle length is occupied by the wicks
   if (UpperWickLength > 0 && CurrentCandleLength > 0) UpperWickPercent = (UpperWickLength / CurrentCandleLength) * 100;
   if (LowerWickLength > 0 && CurrentCandleLength > 0) LowerWickPercent = (LowerWickLength / CurrentCandleLength) * 100;

   
  
}//void CalculateCandleLength(int shift)()

bool SendSingleTrade(int type, string comment, double lotsize, double price, double stop, double take)
{
   
   //if (StopTrading) return(true);
   /*
   if (!IsTesting())
   {   
      if (!IsTradeAllowed() ) return(false);
      if (!IsConnected() ) return(false);
      if (!IsExpertEnabled() ) return(false);
      if (!IsTradeContextBusy() ) return(false);
   }//if (!IsTesting)
   */
   
   int slippage = 10;
   if (Digits == 3 || Digits == 5) slippage = 100;
   
   color col = Red;
   if (type == OP_BUY || type == OP_BUYSTOP) col = Green;
   
   int expiry = 0;
   //if (SendPendingTrades) expiry = TimeCurrent() + (PendingExpiryMinutes * 60);
   
   
   if (!CriminalIsECN) int ticket = OrderSend(Symbol(),type, lotsize, price, slippage, stop, take, comment, MagicNumber, expiry, col);
   
   
   //Is a 2 stage criminal
   if (CriminalIsECN)
   {
      ticket = OrderSend(Symbol(),type, lotsize, price, slippage, 0, 0, comment, MagicNumber, expiry, col);
	   if (ticket > -1)
      {
         if (stop >0 && take > 0) bool result = OrderModify(OrderTicket(), OrderOpenPrice(), stop, take, OrderExpiration(), CLR_NONE);
         //Stop loss but no take profit
         if (stop >0 && take == 0) result = OrderModify(OrderTicket(), OrderOpenPrice(), stop, OrderTakeProfit(), OrderExpiration(), CLR_NONE);
         //Take profit but no stop loss
         if (stop ==0 && take > 0) result = OrderModify(OrderTicket(), OrderOpenPrice(), OrderStopLoss(), take, OrderExpiration(), CLR_NONE);
         if (!result)
         {
             int err=GetLastError();
             Print(Symbol(), " ", type," SL  order modify failed with error(",err,"): ",ErrorDescription(err));
         }//if (!result)			  
      }//if (ticket > -1)
      
   }//if (CriminalIsECN)
   
   //Error trapping for both
   if (ticket < 0)
   {
      string stype;
      if (type == OP_BUY) stype = "OP_BUY";
      if (type == OP_BUYSTOP) stype = "OP_BUYSTOP";
      if (type == OP_SELL) stype = "OP_SELL";
      if (type == OP_SELLSTOP) stype = "OP_SELLSTOP";
      err=GetLastError();
      //Alert(Symbol(), " ", stype," Nanningbob order send failed with error(",err,"): ",ErrorDescription(err));
      Print(Symbol(), " ", stype," #1 Buy Nanningbob order send failed with error(",err,"): ",ErrorDescription(err));
      return(false);
   }//if (ticket < 0)  
   
   //Got this far, so trade send succeeded
   return(true);
   
}//End bool SendSingleTrade(int type, string comment, double lotsize, double price, double stop, double take)

bool DoesTradeExist()
{
   
   
   if (OrdersTotal() == 0) return(false);
   
   for (int cc = OrdersTotal() - 1; cc >= 0 ; cc--)
   {
      if (!OrderSelect(cc,SELECT_BY_POS)) continue;
      
      if (OrderMagicNumber()==MagicNumber && OrderSymbol() == Symbol() )      
      {
         return(true);         
      }//if (OrderMagicNumber()==MagicNumber && OrderSymbol() == Symbol() )      
   }//for (int cc = OrdersTotal() - 1; cc >= 0 ; cc--)

   return(false);

}//End bool DoesTradeExist()

bool No_1_BUY_25_BB()
{

   if (DoesTradeExist()) return(true);
   
   BbLower = iBands(NULL, PERIOD_H4,  25, 2, 0, PRICE_CLOSE, MODE_LOWER, 0); 

   BbUpper = iBands(NULL, PERIOD_H4,  25, 2, 0, PRICE_CLOSE, MODE_UPPER, 0);
 
   bool result = false;
   
   RefreshRates();
   if (Bid < BbLower)
   {
      double stop = NormalizeDouble(Ask - (StopLoss * Point),Digits);
      if (StopLoss == 0) stop = 0;
      double take = NormalizeDouble(Ask + (TakeProfit * Point),Digits);
      if (TakeProfit == 0) take = 0;
      SendSingleTrade(OP_BUY, " ", Lot, Ask, stop, take);      
   }//if (Bid < BbLower)
   
   return(result);

}//bool No_1_BUY_25_BB()

bool No_1_SELL_25_BB()
{

   if (DoesTradeExist()) return(true);
   
   BbLower = iBands(NULL, PERIOD_H4,  25, 2, 0, PRICE_CLOSE, MODE_LOWER, 0); 

   BbUpper = iBands(NULL, PERIOD_H4,  25, 2, 0, PRICE_CLOSE, MODE_UPPER, 0);
 
   bool result = false;
   
   RefreshRates();
   if (Bid > BbUpper)
   {
      double stop = NormalizeDouble(Bid + (StopLoss * Point),Digits);
      if (StopLoss == 0) stop = 0;
      double take = NormalizeDouble(Bid - (TakeProfit * Point),Digits);
      if (TakeProfit == 0) take = 0;
      result = SendSingleTrade(OP_SELL, " ", Lot, Bid, stop, take);      
   }//if (Ask > BbUpper)

   return(result);
   
}//bool No_1_SELL_25_BB()

bool No_2_BUY_1MA_25_BB()
{

   if (DoesTradeExist()) return(true);
   
   bool result = false;

   double  Var1, Var2;
   //---- indicators
   
   // MOVING AVERAGE
   Var1 = iMA(NULL, PERIOD_H4,  1, 0, MODE_LWMA, PRICE_MEDIAN,  0);
   //Var2 = iMA(NULL, PERIOD_H4,  2, 0, MODE_LWMA, PRICE_MEDIAN,  1);

   BbLower = iBands(NULL, PERIOD_H4,  25, 2, 0, PRICE_CLOSE, MODE_LOWER, 0); 

   BbUpper = iBands(NULL, PERIOD_H4,  25, 2, 0, PRICE_CLOSE, MODE_UPPER, 0);
 
   RefreshRates();
   if (Var1 > BbLower)
   {
      double stop = NormalizeDouble(Ask - (StopLoss * Point),Digits);
      if (StopLoss == 0) stop = 0;
      double take = NormalizeDouble(Ask + (TakeProfit * Point),Digits);
      if (TakeProfit == 0) take = 0;
      result = SendSingleTrade(OP_BUY, " ", Lot, Ask, stop, take);      
   }//if (Var2 < BbLower && Var1 > BbLower)


   return(result);

}//bool No_2_BUY_1MA_25_BB()

bool No_2_SELL_1MA_25_BB()
{
   if (DoesTradeExist()) return(true);
   
   bool result = false;

   double  Var1, Var2;
   //---- indicators
   
   // MOVING AVERAGE
   Var1 = iMA(NULL, PERIOD_H4,  1, 0, MODE_LWMA, PRICE_MEDIAN,  0);
   //Var2 = iMA(NULL, PERIOD_H4,  2, 0, MODE_LWMA, PRICE_MEDIAN,  1);

   BbLower = iBands(NULL, PERIOD_H4,  25, 2, 0, PRICE_CLOSE, MODE_LOWER, 0); 

   BbUpper = iBands(NULL, PERIOD_H4,  25, 2, 0, PRICE_CLOSE, MODE_UPPER, 0);
 
   RefreshRates();
   //if (Var2 > BbUpper && Var1 < BbUpper)
   if( Var1 < BbUpper)
   {
      double stop = NormalizeDouble(Bid + (StopLoss * Point),Digits);
      if (StopLoss == 0) stop = 0;
      double take = NormalizeDouble(Bid - (TakeProfit * Point),Digits);
      if (TakeProfit == 0) take = 0;
      result = SendSingleTrade(OP_SELL, " ", Lot, Bid, stop, take);      
   }//if( Var1 < BbUpper)
    


   return(result);

}//bool No_2_SELL_1MA_25_BB()

bool No_3_BUY_BULGE_BB()
{
   
   if (DoesTradeExist()) return(true);
   
   bool result = false;

   double  Var1, Var2;
   //---- indicators
   
   // MOVING AVERAGE
   Var1 = iMA(NULL, PERIOD_H4, 1, 0, MODE_LWMA, PRICE_MEDIAN,  0);
   Var2 = iMA(NULL, PERIOD_H4, 4, 0, MODE_LWMA, PRICE_LOW,  0);
    
   BbLower = iBands(NULL, PERIOD_H4,  25, 2, 0, PRICE_CLOSE, MODE_LOWER, 0); 

   BbUpper = iBands(NULL, PERIOD_H4,  25, 2, 0, PRICE_CLOSE, MODE_UPPER, 0);
 
   RefreshRates();
   if(Bid < Var2 && Var1 > BbLower)
   {
      double stop = NormalizeDouble(Ask - (StopLoss * Point),Digits);
      if (StopLoss == 0) stop = 0;
      double take = NormalizeDouble(Ask + (TakeProfit * Point),Digits);
      if (TakeProfit == 0) take = 0;
      result = SendSingleTrade(OP_BUY, " ", Lot, Ask, stop, take);      
   }//if(Bid < Var2 && Var1 > BbLower)


   return(result);

}//bool No_3_BUY_BULGE_BB()

bool No_3_SELL_BULGE_BB()
{

   if (DoesTradeExist()) return(true);
   
   bool result = false;

   double  Var1, Var2, Var3;
   //---- indicators
   
   // MOVING AVERAGE
   Var1 = iMA(NULL, PERIOD_H4, 1, 0, MODE_LWMA, PRICE_MEDIAN,  0);
   Var2 = iMA(NULL, PERIOD_H4, 4, 0, MODE_LWMA, PRICE_LOW,  0);
   Var3 = iMA(NULL, PERIOD_H4, 4, 0, MODE_LWMA, PRICE_HIGH,  0);
   
   BbLower = iBands(NULL, PERIOD_H4,  25, 2, 0, PRICE_CLOSE, MODE_LOWER, 0); 

   BbUpper = iBands(NULL, PERIOD_H4,  25, 2, 0, PRICE_CLOSE, MODE_UPPER, 0);
 
   RefreshRates();
   if(Bid  > Var3 && Var1 < BbUpper)
   {
      double stop = NormalizeDouble(Bid + (StopLoss * Point),Digits);
      if (StopLoss == 0) stop = 0;
      double take = NormalizeDouble(Bid - (TakeProfit * Point),Digits);
      if (TakeProfit == 0) take = 0;
      result = SendSingleTrade(OP_SELL, " ", Lot, Bid, stop, take);
      
   }//if(Bid  > Var3 && Var1 < BbUpper)
    


   return(result);

}//bool No_3_SELL_BULGE_BB()

bool No_4_BUY_25_BB_or_1x3()
{

   if (DoesTradeExist()) return(true);
   
   bool result = false;

   BbLower = iBands(NULL, PERIOD_H4,  25, 2, 0, PRICE_CLOSE, MODE_LOWER, 0); 

   BbUpper = iBands(NULL, PERIOD_H4,  25, 2, 0, PRICE_CLOSE, MODE_UPPER, 0);
 
   double Var1 = iMA(NULL, PERIOD_H4,  1, 0, MODE_LWMA, PRICE_MEDIAN,  0);
   double Var2 = iMA(NULL, PERIOD_H4,  3, 1, MODE_LWMA, PRICE_MEDIAN,  0);
 
   RefreshRates();
   if (Bid  < BbLower || (Bid > Var2 && Var1 < Var2))
   {
      double stop = NormalizeDouble(Ask - (StopLoss * Point),Digits);
      if (StopLoss == 0) stop = 0;
      double take = NormalizeDouble(Ask + (TakeProfit * Point),Digits);
      if (TakeProfit == 0) take = 0;
      result = SendSingleTrade(OP_BUY, " ", Lot, Ask, stop, take);      
   }//if (Bid  < BbLower || (Bid > Var2 && Var1 < Var2))
    

   return(result);

}//bool No_4_BUY_25_BB_or_1x3()


bool No_4_SELL_25_BB_or_1x3()
{

   if (DoesTradeExist()) return(true);
   
   bool result = false;

   BbLower = iBands(NULL, PERIOD_H4,  25, 2, 0, PRICE_CLOSE, MODE_LOWER, 0); 

   BbUpper = iBands(NULL, PERIOD_H4,  25, 2, 0, PRICE_CLOSE, MODE_UPPER, 0);

   double Var1 = iMA(NULL, PERIOD_H4,  1, 0, MODE_LWMA, PRICE_MEDIAN,  0);
   double Var2 = iMA(NULL, PERIOD_H4,  3, 1, MODE_LWMA, PRICE_MEDIAN,  0);
 
   RefreshRates();
   if(Bid  > BbUpper || (Bid < Var2 && Var1 > Var2))
   {
      double stop = NormalizeDouble(Bid + (StopLoss * Point),Digits);
      if (StopLoss == 0) stop = 0;
      double take = NormalizeDouble(Bid - (TakeProfit * Point),Digits);
      if (TakeProfit == 0) take = 0;
      result = SendSingleTrade(OP_SELL, " ", Lot, Bid, stop, take);      
   }//if(Bid  > BbUpper || (Bid < Var2 && Var1 > Var2))


   return(result);

}//bool No_4_SELL_25_BB_or_1x3()

bool No_7_BUY_25_BB_after_diverge()
{

   OldBars = Bars;
   
   if (DoesTradeExist()) return(true);
   
   bool result = false;

   double RsiValNow = iRSI(NULL, 0, RsiPeriod, PRICE_CLOSE, 1);
   double RsiValThen = iRSI(NULL, 0, RsiPeriod, PRICE_CLOSE, 2);

   CalculateCandleLength(1);
   
   RefreshRates();
   if (Close[1] > Open[1] && High[1] - Low[1] <= (MaximumCandleLength * Point) && RsiValNow > RsiValThen && UpperWickPercent <= AllowableWickPercentage)
   {
      double stop = NormalizeDouble(Ask - (StopLoss * Point),Digits);
      if (StopLoss == 0) stop = 0;
      double take = NormalizeDouble(Ask + (TakeProfit * Point),Digits);
      if (TakeProfit == 0) take = 0;
      result = SendSingleTrade(OP_BUY, " ", Lot, Ask, stop, take);      
      if (!result) OldBars = 0;
   }//if (Close[1] > Open[1] && High[1] - Low[1] <= (MaximumCandleLength * Point) && RsiValNow > RsiValThen && UpperWickPercent <= AllowableWickPercentage)
    
   
   return(result);


}//bool No_7_BUY_25_BB_after_diverge()

bool No_7_SELL_25_BB_after_diverge()
{

   OldBars = Bars;
   
   if (DoesTradeExist()) return(true);
   
   bool result = false;

   double RsiValNow = iRSI(NULL, 0, RsiPeriod, PRICE_CLOSE, 1);
   double RsiValThen = iRSI(NULL, 0, RsiPeriod, PRICE_CLOSE, 2);

   CalculateCandleLength(1);

   RefreshRates();
   if (Close[1] < Open[1] && High[1] - Low[1] <= (MaximumCandleLength * Point) && RsiValNow < RsiValThen && LowerWickPercent <= AllowableWickPercentage)
   {
      double stop = NormalizeDouble(Bid + (StopLoss * Point),Digits);
      if (StopLoss == 0) stop = 0;
      double take = NormalizeDouble(Bid - (TakeProfit * Point),Digits);
      if (TakeProfit == 0) take = 0;
      result = SendSingleTrade(OP_SELL, " ", Lot, Bid, stop, take);      
      if (!result) OldBars = 0;
   }//if (Close[1] < Open[1] && High[1] - Low[1] <= (MaximumCandleLength * Point) && RsiValNow > RsiValThen && LowerWickPercent <= AllowableWickPercentage)
   

   if (result) OldBars = Bars;
   
   return(result);

}//bool No_7_SELL_25_BB_after_diverge()

//+------------------------------------------------------------------+
//| expert start function                                            |
//+------------------------------------------------------------------+
int start()
{
//----
   
   if (RobotSuspended)
   {
      Comment("......................This robot is suspended.................");
      return;
   }//if (RobotSuspended)
   
   
   if (DoesTradeExist()) return;
   
   BbLower = iBands(NULL, PERIOD_H4,  25, 2, 0, PRICE_CLOSE, MODE_LOWER, 0); 

   BbUpper = iBands(NULL, PERIOD_H4,  25, 2, 0, PRICE_CLOSE, MODE_UPPER, 0);
 
   bool result;
   
   if (Trade_1_BUY_25_BB) result = No_1_BUY_25_BB();
   if (Trade_1_SELL_25_BB) result = No_1_SELL_25_BB();
   if (Trade_2_BUY_1MA_25_BB) result = No_2_BUY_1MA_25_BB();
   if (Trade_2_SELL_1MA_25_BB) result = No_2_SELL_1MA_25_BB();
   if (Trade_3_BUY_BULGE_BB) result = No_3_BUY_BULGE_BB();
   if (Trade_3_SELL_BULGE_BB) result = No_3_SELL_BULGE_BB();
   if (Trade_4_BUY_25_BB_or_1x3) result = No_4_BUY_25_BB_or_1x3();
   if (Trade_4_SELL_25_BB_or_1x3) result = No_4_SELL_25_BB_or_1x3();
   if (Trade_7_BUY_25_BB_post_diverge && OldBars != Bars)  result = No_7_BUY_25_BB_after_diverge();
   if (Trade_7_SELL_25_BB_post_diverge && OldBars != Bars)  result = No_7_SELL_25_BB_after_diverge();
   
   
   
   if (result && UseSafetyFeature) 
   {
      RobotSuspended = true;
      Alert(Symbol() + " NB EA has sent a trade and suspended itself");
   }//if (result) 
   
    

//----
   return(0);
}
//+------------------------------------------------------------------+